import webpack, { Configuration as WebpackConfiguration } from "webpack";
import { BuilderContext } from "./tasks";
export declare const packageName: any;
export declare const packageVersion: any;
export declare const defaultExperiment = "experiment";
export declare const builderDir: string;
export declare const builderAssetsDir: string;
export declare const builderNodeModulesDir: string;
export declare const distPath: string;
export interface UserConfig {
    webpack?: (config: WebpackConfiguration) => WebpackConfiguration;
}
/**
 * Load `builder.config.js`. If the file is present, returns the module loaded from it.
 * Otherwise, returns undefined.
 */
export declare function loadUserConfig(): Promise<any>;
export declare const getWebpackConfig: (context: BuilderContext) => webpack.Configuration;
export declare function getJatosStudyMetadata(slug: string, title: string, description: string, version: string): {
    version: string;
    data: {
        uuid: string;
        title: string;
        description: string;
        groupStudy: boolean;
        linearStudy: boolean;
        dirName: string;
        comments: string;
        jsonData: null;
        endRedirectUrl: null;
        componentList: {
            uuid: string;
            title: string;
            htmlFilePath: string;
            reloadable: boolean;
            active: boolean;
            comments: string;
            jsonData: null;
        }[];
        batchList: {
            uuid: string;
            title: string;
            active: boolean;
            maxActiveMembers: null;
            maxTotalMembers: null;
            maxTotalWorkers: null;
            allowedWorkerTypes: null;
            comments: null;
            jsonData: null;
        }[];
    };
};
